#include <iostream>
#include <lemon/smart_graph.h>
#include <lemon/invalid.h>
#include <lemon/graph_reader.h>
#include <lemon/graph_writer.h>


using namespace lemon;

int main() {
  SmartGraph graph;

  try {
    std::string filename="sample.lgf";
    GraphReader<SmartGraph> reader(filename,graph);
    SmartGraph::EdgeMap<int> cap(graph);
    reader.readEdgeMap("capacity",cap);
//     reader.readNode("source",s).readNode("target",t)
//       .readEdgeMap("capacity",cap).run();
    reader.run();

    std::cout << "Hello! We have read a graph from file " << filename<< 
      " and some maps on it: now we write this to the standard output!" << 
      std::endl;


    GraphWriter<SmartGraph> writer(std::cout, graph);
    writer.writeEdgeMap("multiplicity", cap);
//     writer.writeNode("source", s);
//     writer.writeNode("target", t);
    writer.run();
     
//     LemonReader reader(std::cin);

//     NodeSetReader<SmartGraph> nodeset(reader, graph);
//     SmartGraph::NodeMap<int> cost(graph);
//     nodeset.readMap("cost", cost);
//     SmartGraph::NodeMap<char> mmap(graph);
//     nodeset.readMap("mmap", mmap);

//     EdgeSetReader<SmartGraph> edgeset(reader, graph, nodeset);
//     SmartGraph::EdgeMap<std::string> description(graph);
//     edgeset.readMap<QuotedStringReader>("description", description);

//     NodeReader<SmartGraph> nodes(reader, nodeset);
//     SmartGraph::Node source;
//     nodes.readNode("source", source);
//     SmartGraph::Node target;
//     nodes.readNode("target", target);

//     AttributeReader<> attribute(reader, "gui");
//     std::string author;
//     attribute.readAttribute<LineReader>("author", author);
//     int count;
//     attribute.readAttribute("count", count);

//     PrintReader print(reader);

//     reader.run();


//     for (SmartGraph::NodeIt it(graph); it != INVALID; ++it) {
//       std::cout << cost[it] << ' ' << mmap[it] << std::endl;
//     }

//     for (SmartGraph::EdgeIt it(graph); it != INVALID; ++it) {
//       std::cout << description[it] << std::endl;
//     }

//     std::cout << "author: " << author << std::endl;
//     std::cout << "count: " << count << std::endl;

//     std::cout << "source cost: " << cost[source] << std::endl;
//     std::cout << "target cost: " << cost[target] << std::endl;

//     std::cout.flush();
  } catch (DataFormatError& error) {
    std::cerr << error.what() << std::endl;
  }


  return 0;
}
